//#include <EthernetENC.h>
#include <SPI.h>
//#include <UIPEthernet.h>
#include <Ethernet.h>
// set value
String LogerID = "PO-RSBIRING;TNLG002"; //7 char only - RS Sembiring
int maxcomretry = 300;
int Bat145 = 690;// analogRead(5) for battery 14.5 volts
int mKirim = 5; // jangka kirim (menit)
int mSample = 2; // jangka sampling (menit)

//runtime variable
char serverName[] = "scadatirtanadi.mooo.com";
unsigned long DCount[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
boolean DLast[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
unsigned long secTimeBase = 0;
unsigned long lastime = 0;
unsigned long lasTM = 0;
unsigned long comstartime = 0;
unsigned long AnRead = 0;
String sCom, sC1, sC2, sC3, sC4; 
int constatus = 0;
int comretry = 0;
int uBaca = 0;

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};

//IPAddress ip(192, 168, 1, 211);
// Enter the IP address of the server you're connecting to:
IPAddress server(202, 152, 39, 218);

// Initialize the Ethernet client library
// with the IP address and port of the server
EthernetClient client;

void(*resetFunc)(void) = 0; //reset function @ address 0

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("\r\nSTARTING");
  sComRead();
}

void loop () {
  // sending sample
  if (((millis() / 60000) % mKirim == 0) && (sCom.startsWith("A0-") == 1))  {
    ComSend();
  }
  // read sample
  if (((millis() / 60000) % mSample == 0) && ((millis() / 60000) != lasTM)) {
    Serial.println("Sampling " + String(mKirim - (millis() / 60000) % mKirim));
    sComRead();
    lasTM = millis() / 60000 ;
  }
  mydelay(10);
}

void ComSend() {
  Serial.println("Sending");
  comstartime = millis();
  comretry = 0;
  SetModemON();
  // if you get a connection, report back via serial:
  constatus = client.connect(serverName, 6013);
  while ((constatus != 1) && (comretry < maxcomretry) && (millis() < (comstartime + 180000))) {
    Serial.println("fail " + String(constatus) + " retry " + String(comretry));
    comretry = comretry + 1;
    mydelay(1);
    constatus = client.connect(serverName, 6013);
    if (comretry >= maxcomretry) {
      Serial.println("Skip");
    }
  }
  if (constatus == 1) {
    Serial.println("connected");
  }

  if (client.connected()) {
    //if (sCom.startsWith("A0-") != 1) {
    //  resetFunc();
    //}
    //Serial.println(sC30 + sC29 + sC28 + sC27 + sC26 + sC25 + sC24 + sC23 + sC22 + sC21 + sC20 + sC19 + sC18 + sC17 + sC16 + sC15 + sC14 + sC13 + sC12 + sC11 + sC10 + sC9 + sC8 + sC7 + sC6 + sC5 + sC4 + sC3 + sC2 + sCom + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    Serial.println(sC4 + sC3 + sC2 + sC1 + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    //client.print(sC30 + sC29 + sC28 + sC27 + sC26 + sC25 + sC24 + sC23 + sC22 + sC21 + sC20 + sC19 + sC18 + sC17 + sC16 + sC15 + sC14 + sC13 + sC12 + sC11 + sC10 + sC9 + sC8 + sC7 + sC6 + sC5 + sC4 + sC3 + sC2 + sCom + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    client.print(sC4 + sC3 + sC2 + sC1 + "MR-" + String((millis() - comstartime) / 1000) + ";" + LogerID);
    client.stop();
    Serial.println("send " + String(millis() - comstartime) + " mS");
    comretry = 0;
    // matikan modem
    SetModem(LOW);
    ClrsCom();
  }
  // matikan modem
  SetModem(LOW);

}

void SavesCom() {
  // shift save
  // sC30 = sC29; sC29 = sC28; sC28 = sC27; sC27 = sC26; sC26 = sC25;
  // sC25 = sC24; sC24 = sC23; sC23 = sC22; sC22 = sC21; sC21 = sC20;
  // sC20 = sC19; sC19 = sC18; sC18 = sC17; sC17 = sC16; sC16 = sC15;
  // sC15 = sC14; sC14 = sC13; sC13 = sC12; sC12 = sC11; sC11 = sC10;
  // sC10 = sC9; sC9 = sC8; sC8 = sC7; sC7 = sC6; sC6 = sC5;
  // sC5 = sC4;  
  sC4 = sC3; sC3 = sC2; sC2 = sC1; sC1 = sCom;
}

void ClrsCom() {
  //sC30 = ""; sC29 = ""; sC28 = ""; sC27 = ""; sC26 = "";
  //sC25 = ""; sC24 = ""; sC23 = ""; sC22 = ""; sC21 = "";
  //sC20 = ""; sC19 = ""; sC18 = ""; sC17 = ""; sC16 = "";
  //sC15 = ""; sC14 = ""; sC13 = ""; sC12 = ""; sC11 = "";
  //sC10 = ""; sC9 = ""; sC8 = ""; sC7 = ""; sC6 = "";
  // sC5 = "";  
  sC4 = ""; sC3 = ""; sC2 = ""; sC1 = ""; sCom = "";
}

void mydelay(int detik) {
  for (int pin = 1; pin <= detik; pin++) {
    msecdelay(1000);
    Serial.print(String(pin) + ".");
    if ((millis() / 60000) > 1000) {
      resetFunc();
    }
  }
  Serial.println(" ");

}

void msecdelay(unsigned long mDetik) {
  // baca counter digital hingga transmisi serial berikutnya
  lastime = millis();
  uBaca = 0;
  while (millis()  < (lastime + mDetik)) {
    uBaca++;
    //reset jika milis kembali 0
    if (millis() < lastime) {
      lastime = millis();
    }
    // read digital value
    for (int pin = 5; pin <= 9; pin++) {
      pinMode(pin, INPUT);
      boolean DigiState = digitalRead(pin);
      // count when state change high to low
      if ((DLast[pin - 2] == HIGH) and (DigiState == LOW))
      {
        DCount[pin - 2] = DCount[pin - 2] + 1;
      }
      DLast[pin - 2] = DigiState;
    }
  }
  // Serial.println("uBaca " + String(uBaca));
}

void SetSensor(boolean bStatus) {
  pinMode(3, OUTPUT);
  digitalWrite(3, !bStatus);
}

void SetModem(boolean bStatus) {
  pinMode(2, OUTPUT);
  digitalWrite(2, !bStatus);
}

void SetModemON() {
  CheckBat();
  //if battery > 12V
  if (analogRead(5) >= (12 * Bat145 / 14.5)) {
    SetModem(HIGH);
    Serial.println("PowerUp modem");
    mydelay(20); //wait for modem to be ready
    Serial.println("Init Eth");
    // You can use Ethernet.init(pin) to configure the CS pin
    Ethernet.init(10);  // Most Arduino shields
    // start the Ethernet connection:
    // Ethernet.begin(mac, ip);
    Ethernet.begin(mac);
    Serial.println("connect router");
    mydelay(10);
    Ethernet.maintain();
    Serial.print(Ethernet.localIP());
    Serial.println(" connect server 20s");
    // give the Ethernet shield a second to initialize:
    mydelay(20);
  }
}

void CheckBat() {
  // when battery low, wait until battery rise
  while (analogRead(5) < (12 * Bat145 / 14.5)) {
    SetModem(LOW);
    SetSensor(LOW);
    Serial.println("Bat Lo, idle 30m");
    mydelay(30 * 60);
  }
  Serial.print("Batt " + String(analogRead(5)) + " ");
  Serial.println(String(((analogRead(5) * 14.5 / Bat145))));
}

void sComRead() {
  CheckBat();
  SetSensor(HIGH); //activate sensor
  mydelay(5);
  sCom = "";
  // read the analog in value:
  for (int pin = 0; pin <= 2; pin++) {
    // cleaning last reading
    for (int ulang = 0; ulang <= 10; ulang++) {
      AnRead = analogRead(pin);
      delay(2);
    }
    AnRead = 0;
    for (int ulang = 1; ulang <= 5; ulang++) {
      AnRead = analogRead(pin) + AnRead;
      delay(1);
    }
    AnRead = AnRead / 5;
    sCom = sCom + "A" + String(pin) + "-" + String(AnRead) + ";";
  }
  // digital value
  sCom = sCom + "D-";
  // in D5-D9
  for (int pin = 5; pin <= 7; pin++) {
    sCom = sCom + String(digitalRead(pin));
  }
  sCom = sCom + ";" ;
  // digital counter
  for (int pin = 5; pin <= 7; pin++) {
    sCom = sCom + "C" + String(pin) + "-" + String(DCount[pin - 2]) + ";";
  }
  sCom = sCom + "BT-" + String(((analogRead(5) * 14.5 / Bat145) * 10), 0) + ";";
  sCom = sCom + "TM-" + String(millis() / 60000) + ";";
  Serial.println(sCom);
  SetSensor(LOW); //deactivate sensor
  SavesCom();
}
